# モジュール読み込み ******************************************************
import time
import requests
# ｔime: 時間に関するPython標準モジュール
# requests： HTTPリクエストに関するPythonモジュールです。

# LINE発信　LINENotify **************************************************
LINETOKEN = "□□□□□□□□□□□□□□□□□□□□"
# LINE通知用トークン ※自分のLINEのマイページから取得します。

url_LINENotifyAPI = "https://notify-api.line.me/api/notify"
# LINENotyfyのAPIのURLです。


def siro_Line(LINE_message):
    # LINENotifyを使って自分のLINEにメッセージ(引数LINE_messageで指定)を通知する関数を定義しています。

    headers = {'Authorization': 'Bearer ' + LINETOKEN}
    payload = {'message': LINE_message}
    requests.post(url_LINENotifyAPI, headers=headers, data=payload)
    # LINENotifyAPIにPOSTリクエストを送っています。


def siro_Line_file(LINE_message, LINE_file):
    # LINENotifyを使って自分のLINEにメッセージ及びファイル送信(引数LINE_message、LINE_fileで指定)を行う関数を定義しています。

    headers = {'Authorization': 'Bearer ' + LINETOKEN}
    payload = {'message': LINE_message}
    files = {"imageFile": open(LINE_file, "rb")}
    requests.post(url_LINENotifyAPI, headers=headers, params=payload, files=files)
    # LINENotifyAPIにPOSTリクエストを送っています。


# メイン処理 *************************************************************
try:
    while True:

        siro_Line("こんにちわ")
        siro_Line_file("こんにちわ", "/home/kuro/kurosSIRO/neko.png")
        # 定義した関数を使ってメッセージと準備したサンプル画像ファイルを送ってみます。

        time.sleep(5)

# 終了処理　*************************************************************
# Ctl + C キーボード割り込み
except KeyboardInterrupt as reigai:
    print("Ctl C ........")

finally:  # 終了処理
    print("SIRO stopping............")

# End of program ●▲■●▲■●▲■●▲■■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■
