# モジュール読み込み ******************************************************
import time
from upspackv2 import *  # UPS専用モジュール
# ｔime: 時間に関するPython標準モジュールです。
# upspackv2:GitHub（https://github.com/rcdrones/UPSPACK_V3/）に公開されているPythonモジュールです。
# プロジェクトフォルダ（筆者の場合は/home/kuro/kurosSIRO）に保存します。

# バッテリー残量検知 ******************************************************
vin = ""  # UPSへの入力：UPSが充電中であれば“GOOD”,充電していなければ“NG”となります。
vout = 0.0  # UPS出力電圧[mV]
batcap = 0  # バッテリー残量 0～100[％]
# 変数を定義します。

UPS = UPS2("/dev/ttyAMA0")
# UPS2クラスのインスタンス生成、初期化処理を行っています。

# メイン処理 *************************************************************
try:
    while True:

        version, vin, batcap, vout = UPS.decode_uart()
        # クラスメソッドを使ってUPSとUART通信を行いデータを取得しています。

        print("充電：", vin)
        print("バッテリ残量：", batcap, "%")
        print("出力電圧：", vout, "[mV]")
        # UPSから取得したデータを表示します。

        time.sleep(1)
        # 1秒ごとにデータを取得します。

# 終了処理 **************************************************************
# Ctrl + C キーボード割り込み
except KeyboardInterrupt as reigai:
    print("Ctrl C ........")

finally:  # 終了処理
    print("SIRO stopping............")

# End of program  ■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲ 
