# モジュール読み込み ******************************************************
import time
import os
import subprocess
# ｔime: 時間に関するPython標準モジュールです。
# os: os機能に関するPython標準モジュールです。
# subproces：プロセス管理に関するPython標準モジュールです。

# 発話　OpenJtalk *******************************************************
sp_vol = 30  # スピーカー音量 50~100で調整
# スピーカー音量を調整するためのパラメータを定義しています。


def siro_speak(serif):
    # 発話用の関数を定義しています。引数serif（文字列）を音声合成して発話します。

    global sp_vol
    # グローバル宣言しています。
    # 参照だけなら本当はいらないのですが筆者はとりあえず宣言しておくことにしています。

    cmd = "amixer cset numid=3 "+str(sp_vol)+"%"  # 音量set
    subprocess.call(cmd.split())
    # amixer（標準コマンド）を使ってスピーカー音量を設定しています
    # subprocess.callでコマンドを実行しています。

    # voice = " -m /usr/share/hts-voice/nitech-jp-atr503-m001/nitech_jp_atr503_m001.htsvoice" # 男性の声
    voice = " -m /usr/share/hts-voice/mei/mei_normal.htsvoice"  # 女性の声
    dic = " -x /var/lib/mecab/dic/open-jtalk/naist-jdic"  # 辞書ファイル
    # 使用する音声ファイルと辞書ファイルを指定しています。

    option = " -r 0.8 -fm 5"
    # OpenJtalkの音声パラメータを設定しています。指定しないとデフォルト値になるようです。
    # -a   オールパス値/声の質が変わります。　
    #      小さいとキテレツ大百科のコロスケみたいな声になります。大きいとおっさんみたいな声になります。1.0の前後で調整します。
    # -b   ポストフィルター係数/ 使い方がよくわかりませんでした。
    # -r   スピーチ速度係数/ 話すスピードが変わります。1.0がデフォルトなのでその前後で調整します。
    # -fm  追加ハーフトーン/ 声の高さが変わります。0.0 がデフォルトです。-15~15で調整しました。
    # -u   有声/無声境界値/ 使い方がよくわかりませんでした。
    # -jm  スペクトラム系列内変動の重み/ 抑揚が変わります。
    #      小さくするとロボットみたいな感じに、大きくするとミニオンみたいな声になります。1.0がデフォルトで0.5〜5.0で調整します。
    # -jf  FO系列内変動の重み/ 音量が変わります。0.5〜2.0で調整します。

    cmd = "echo " + serif + " | open_jtalk" + dic + voice + option + " -ow /tmp/siro_openjtalk.wav"
    os.system(cmd)
    # 文字列serif から音声ファイルsiro_OpenJtalk.wavを生成しています。
    # 音声ファイルは/tmp に保存し発話の都度ファイルを更新します。
    # 文字列serif を標準入力でOpen_Jtalkに入力するのにechoコマンドとパイプ|を使用しています。
    # os.systemを使ってコマンドを実行しています。

    cmd = "aplay /tmp/siro_openjtalk.wav"  # aplayで音声ファイル再生
    subprocess.call(cmd.split())
    # Open_Jtalkで生成した音声ファイルsiro_OpenJtalk.wavをaplay(標準コマンド)で再生しています。


# メイン処理  ************************************************************
try:
    while True:

        # 定義した関数siro_speak(serif)を使ってSIROにおしゃべりさせます。
        siro_speak("おはようございます。")
        siro_speak("こんにちは")
        siro_speak("今日はいい天気ですね。")

        time.sleep(3)
        # 3秒毎に実行します。

# 終了処理 **************************************************************
# Ctrl + C キーボード割り込み
except KeyboardInterrupt as reigai:
    print("Ctrl C ........")

finally:  # 終了処理
    print("SIRO stopping............")

# End of program ●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■
