# モジュール読み込み *******************************************************
import wikipedia
# ウィキペディア検索用Pythonモジュールです。

# ウィキペディア検索 *******************************************************
wiki_result = ""
# 検索結果を保存する変数です。


def wikipedia_search(word):
    # ウィキペディア検索用関数です。引数wordをウィキペディアで検索します。

    global wiki_result

    wikipedia.set_lang('ja')
    # 言語に日本語を設定しています。

    candidate_list = wikipedia.search(word)
    # 引数wordをウィキペディア検索します。

    if not candidate_list:

        wiki_result = "該当する単語が存在しませんでした。"
        # 該当する単語がなければ該当なしと回答します。

    else:
        try:
            wiki_result = wikipedia.summary(candidate_list[0])
            # 要約部分を抽出します。

        except Exception as e:
            # エラーの場合もプログラムが停止しないよう例外処理を行います。
            wiki_result = "検索エラーです。混乱してます。"


# メイン処理   ***********************************************************
try:

    wikipedia_search("猫")
    print(wiki_result)
    # 適当な単語（ここでは猫）で検索して結果を表示します。

# 終了処理　**************************************************************
# Ctrl + C キーボード割り込み
except KeyboardInterrupt as reigai:
    print("Ctrl C ........")

finally:  # 終了処理
    print("SIRO stopping............")

# End of program ●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●▲■●
